package ru.dbotthepony.mc.otm.data

import com.google.gson.JsonElement
import com.mojang.datafixers.util.Pair
import com.mojang.serialization.Codec
import com.mojang.serialization.DataResult
import com.mojang.serialization.DynamicOps
import com.mojang.serialization.JsonOps

object JsonElementCodec : Codec<JsonElement> {
	override fun <T : Any> encode(input: JsonElement, ops: DynamicOps<T>, prefix: T): DataResult<T> {
		return DataResult.success(JsonOps.INSTANCE.convertTo(ops, input))
	}

	override fun <T : Any> decode(ops: DynamicOps<T>, input: T): DataResult<Pair<JsonElement, T>> {
		return DataResult.success(Pair(ops.convertTo(JsonOps.INSTANCE, input), ops.empty()))
	}
}
